/* 
 * Tenshi no Hashigo for X
 * Copyright (c) 2001 TF <tf@denpa.org>
 * All rights reserverd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: $
 */
#ifndef __INCLUDE_XIMAGE_H
#define __INCLUDE_XIMAGE_H
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/XShm.h>

typedef struct TrueColorMap {
  long red[256];
  long green[256];
  long blue[256];
} TrueColorMap;

typedef struct {
  XImage *ximage;           /*  XImage */
  Display *display;         /* ɽоݤˤʤäƤǥץ쥤 */
  Window window;            /* ɽоݤˤʤäƤ륦ɥ   */
  Colormap colormap;        /* Ѥ륫顼ޥå */
  GC gc;                    /* Default GC of Screen */
  Pixmap pixmap;            /* Pixmap */
  unsigned char *rgbmap;    /* RGB ¤ӤΥӥåȥޥå */
  
  int visual_class;         /* Visual Class */
  
  /* for TrueColor */
  TrueColorMap *tcmap;

  /* for PseudoColor */
  long allocated_pixel[256];
  int pixel_num;
  
  /* offset relative to top-left of window */
  int xoffset;
  int yoffset;
  
  /* shared memory info. */
  Bool support_shmem;
  Bool support_shpix;
  XShmSegmentInfo shminfo;

} XLImage;

#endif __INCLUDE_IMAGE_H
